﻿Imports Infragistics.Web.UI.LayoutControls
Imports Infragistics.Web.UI.EditorControls
Imports Infragistics.Web.UI

Partial Class _Default
    Inherits System.Web.UI.Page


    Private Sub Page_Init(sender As Object, e As System.EventArgs) Handles Me.Init
        If gAFData Is Nothing Then
            InitAfData()
        End If
        wddPlantList.DataSource = gAFData.GetPlantList()
        wddPlantList.DataBind()

    End Sub

    Protected Sub Page_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        If gAFData.Connected = False Then
            InitAfData()
        End If

        If Not Page.IsPostBack Then
            Dim Plant As AFElement = gAFData.GetPlant(0)
            Session.Add("SelectedPlant", Plant.Name)
            Master.PageHeaderText = Plant.Name + " Centerline Data"
            CreateDynamicGauges(gAFData.GetPBOParams(Plant.Name))
        Else
            Master.PageHeaderText = wddPlantList.CurrentValue + " Centerline Data"
            Session.Add("SelectedPlant", wddPlantList.CurrentValue)
            CreateDynamicGauges(gAFData.GetPBOParams(wddPlantList.CurrentValue))
        End If
    End Sub

    Private Sub InitAfData()
        gAFData = New AFData(WebConfigurationManager.AppSettings("AFServer"),
                    WebConfigurationManager.AppSettings("AFDatabase"),
                    WebConfigurationManager.AppSettings("AccountName"),
                    WebConfigurationManager.AppSettings("AccountPassword"),
                    WebConfigurationManager.AppSettings("AccountDomain"))
    End Sub

    Public Sub CreateDynamicGauges(PBOParameters As AFElements)
        'Clear Div DynamicGauges of Controls
        DynamicGauges.Controls.Clear()

        'Determine the max number of table rows required
        Dim MaxRows As Integer = (PBOParameters.Count / 4) 'Integer Division : drops Fractions
        If (PBOParameters.Count - 2) Mod 4 <> 0 Then
            MaxRows = MaxRows + 1
        End If

        'Dyanmically build table
        Dim tbl As New Table
        For row As Integer = 0 To MaxRows
            Dim tr As New TableRow
            For Cols As Integer = 0 To 3
                Dim tc As New TableCell
                tc.Width = 225
                tr.Cells.Add(tc)
            Next
            tbl.Rows.Add(tr)
        Next

        'Add Controls to Table
        For ParamIndex As Integer = 0 To PBOParameters.Count - 1
            Dim RowIndex As Integer = ParamIndex \ 4
            Dim CellIndex = ParamIndex - RowIndex * 4
            Dim PlantParam As AFElement = PBOParameters(ParamIndex)
            Dim ucGauge As PBOMonitor = LoadControl("PBOMonitor.ascx")
            ucGauge.ID = "Gauge" + CStr(ParamIndex)
            ucGauge.PBOParam = PlantParam
            tbl.Rows(RowIndex).Cells(CellIndex).Controls.Add(ucGauge)
        Next

        'Add table to Div DynamicGauges 
        DynamicGauges.Controls.Add(tbl)

    End Sub




End Class


